# How to contribute

## Submitting changes

Please send a Merge Request for your changes. Please follow our coding conventions (below) and make sure all of your commits are atomic (one functional unit per commit).

Always write a clear descriptive log message for each of your commits. For example:

```
    $ git commit -m "A brief summary of the commit
    >
    > A paragraph describing what changed and its impact."
```

Example of commit messages we will not approve:
```
    $ git commit -m "new version"
```

```
    $ git commit -m "41"
```

```
    $ git commit -m "bump"
```

Feel free to use GitMojis (https://gitmoji.carloscuesta.me/).

Name your single issue branches aimed for MR as `<issue-number>-issue-description` so the issue will get linked to that branch. Same as mentioning issue number (with `#`) in commit message (example `$ git commit -m "A brief summary of the commit related to #34`).

## Code style guide and design decisions

- `app` is a core part of the application.
- `assets` is a folder containing fonts, images and other assets.
- `styles` is a folder containing global styles for the application.
- `environments` are our environment-specific build-time configurations that we use.
- We use React hooks.
- We use MobX for state management.
- We use Async/Await for asynchronous stuff (try to avoid callbacks or Promises).
- We use OOP, try to design your changes with this in mind - use Classes, Interfaces, inheritance so that it makes sense.
- We use TypeScript for a reason - try to avoid using :any or not defining types at all.
- Study our class hierarchy and make your additions fit it.
- Name variables and properties by their purpose.
- Name functions and methods by their purpose, not their implementation.
- We use ES6 and its features, array destructing, spread, rest,...

## Coding conventions

Start reading our code and you'll get the hang of it. We optimize for readability:

- We use TSLint with slightly edited `recommended` settings, see our `tslint.json` file.
- We use TypeDoc for code documentation. Document all your classes with JavaDoc-styled comments.
- We always put spaces after list items and method parameters (`[1, 2, 3]`, not `[1,2,3]`), around operators (`x += 1`, not `x+=1`), and in curly brackets (`import { log } from '../../core/Logger';` not `import {log} from '../../core/Logger';`).
- This is open source software. Consider the people who will read your code, and make it look nice for them.
